---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by brode.
--- DateTime: 11.06.2021 16:11
---
local _, BohemkaDKP = ...

function BohemkaDKP:dump(o)
    if type(o) == 'table' then
        local s = '{ '
        for k,v in pairs(o) do
            if type(k) ~= 'number' then k = '"'..k..'"' end
            s = s .. '['..k..'] = ' .. BohemkaDKP:dump(v) .. ','
        end
        return s .. '} '
    else
        return tostring(o)
    end
end

function BohemkaDKP:debugMessage(...)
    str = ''
    if type(...) == 'table' then
        str = BohemkaDKP:dump(...)
    else
        for _,v in pairs({...}) do
            str = str .. tostring(v) .. ' '
        end
    end
    print(string.format(BohemkaDKP.STRING.DEBUG, self:colorize(BohemkaDKP.NAME, self.COLOR.ADDON), str))
end

function BohemkaDKP:Debug(...)
    if not BohemkaDKPConfig.debug then
        return
    end
    self:debugMessage(...)
end


function BohemkaDKP:Print(...)
    BohemkaDKP:debugMessage(...)
end

function BohemkaDKP:RepeatAfter(duration, cb)
    cb()
    C_Timer.After(duration, function () BohemkaDKP:RepeatAfter(duration, cb) end)
end

function BohemkaDKP:GetPlayerName(useFullName)
    if useFullName then
        local fullName, realm = UnitFullName("player")
        return fullName.."-"..(realm or GetNormalizedRealmName())
    end
    return UnitName("player")
end


function BohemkaDKP:roundWhole(num, l)
    return math.floor(num / l + 0.5) * l
end

function BohemkaDKP:colorize(text, color)
    local escapeColor = format("|cff%02x%02x%02x", color.r*255, color.g*255, color.b*255)
    return escapeColor..text.."|r"
end


function BohemkaDKP:IsPlayerLootMaster()
    local _, masterlooterPartyID, _ = GetLootMethod()
    return masterlooterPartyID == 0
end

function BohemkaDKP:isDigit(value)
    value = tonumber(value)
    if value then
        return true
    end
    return false
end

function BohemkaDKP:GetNumVisibleGuildMembers()
    local totalMembers, onlineMembers, _ = GetNumGuildMembers();
    local numGuildMembers = 0;
    local showOffline = GetGuildRosterShowOffline();
    if (showOffline) then
        numGuildMembers = totalMembers;
    else
        numGuildMembers = onlineMembers;
    end
    return numGuildMembers
end

table.toString = function(t)
    local tableStr = {}
    BohemkaDKP:Debug(t)
    for k,v in pairs(t) do
        table.insert(tableStr, k.."="..v)
    end
    return table.concat(tableStr, ",")
end

table.fromString = function(str)
    local data = { strsplit(",", str) }
    local t = {}
    for _, item in ipairs(data) do
        local k, v = strsplit("=", item)
        t[k] = v
    end
    return t
end

function BohemkaDKP:deepCopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[self:deepCopy(orig_key)] = self:deepCopy(orig_value)
        end
        setmetatable(copy, self:deepCopy(getmetatable(orig)))
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end
function BohemkaDKP:splitStringByChunks(text, size)
    local s = {}
    for i=1, #text, size do
        s[#s+1] = text:sub(i,i+size - 1)
    end
    return s
end

local b='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'

-- encoding
function BohemkaDKP:encodeBase64(data)
    return ((data:gsub('.', function(x)
        local r,a='',x:byte()
        for i=8,1,-1 do r=r..(a%2^i-a%2^(i-1)>0 and '1' or '0') end
        return r;
    end)..'0000'):gsub('%d%d%d?%d?%d?%d?', function(x)
        if (#x < 6) then return '' end
        local c=0
        for i=1,6 do c=c+(x:sub(i,i)=='1' and 2^(6-i) or 0) end
        return b:sub(c+1,c+1)
    end)..({ '', '==', '=' })[#data%3+1])
end

-- decoding
function BohemkaDKP:decodeBase64(data)
    data = string.gsub(data, '[^'..b..'=]', '')
    return (data:gsub('.', function(x)
        if (x == '=') then return '' end
        local r,f='',(b:find(x)-1)
        for i=6,1,-1 do r=r..(f%2^i-f%2^(i-1)>0 and '1' or '0') end
        return r;
    end):gsub('%d%d%d?%d?%d?%d?%d?%d?', function(x)
        if (#x ~= 8) then return '' end
        local c=0
        for i=1,8 do c=c+(x:sub(i,i)=='1' and 2^(8-i) or 0) end
        return string.char(c)
    end))
end
function BohemkaDKP:AddRealmName(name)
    if not string.find(name, "-") then
        name = name.."-"..GetNormalizedRealmName()
    end
    return name
end
table.removeNil = function(t)
    local tmp = {}
    for _,v in pairs(t) do
        tmp[ #tmp+1 ] = v
    end
    return tmp
end
function BohemkaDKP:GetBagPosition(itemLink)
    for bag = 0, NUM_BAG_SLOTS do
        for slot = 1, GetContainerNumSlots(bag) do
            if(GetContainerItemLink(bag, slot) == itemLink) then
                return bag, slot
            end
        end
    end
end
function BohemkaDKP:split(s, delimiter)
    result = {};
    for match in (s..delimiter):gmatch("(.-)"..delimiter) do
        table.insert(result, match);
    end
    return result;
end
