---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by brode.
--- DateTime: 15.07.2021 17:54
---
local _, BohemkaDKP = ...

function BohemkaDKP:AddDKPSelected(value, channel, reason, percent)
    for name, state in pairs(BohemkaDKP.editModeSelected) do
        if state then
            self:AddDKP(self.rosterIndex[name], value, channel, reason, percent)
        end
    end
end
function BohemkaDKP:SubtractDKPSelected(value, channel, reason, percent)
    for name, state in pairs(BohemkaDKP.editModeSelected) do
        if state then
            self:SubtractDKP(self.rosterIndex[name], value, channel, reason, percent)
        end
    end
end
function BohemkaDKP:SubtractDKP(index, value, channel, reason, percent)
    local currentValue = BohemkaDKP:NoteDKPToNumber(select(7, GetGuildRosterInfo(index)))
    BohemkaDKP:SaveDKP(index, percent and currentValue - (currentValue * value/100) or currentValue - value, channel, reason)
end
function BohemkaDKP:SetDKP(index, value, channel, reason, percent)
    local currentValue = BohemkaDKP:NoteDKPToNumber(select(7, GetGuildRosterInfo(index)))
    BohemkaDKP:SaveDKP(index, percent and currentValue * value/100 or value, channel, reason)
end
function BohemkaDKP:AddDKP(index, value, channel, reason, percent)
    local currentValue = BohemkaDKP:NoteDKPToNumber(select(7, GetGuildRosterInfo(index)))
    BohemkaDKP:SaveDKP(index, percent and currentValue + (currentValue * value/100) or currentValue + value, channel, reason)
end

function BohemkaDKP:AwardDKPRaid(value, reason)
    local members = GetNumGroupMembers();
    local realmName = GetNormalizedRealmName()
    for i = 1, members do
        local name = GetRaidRosterInfo(i)
        name, realm = UnitFullName(name)
        if not realm or #realm <= 0 then
            realm = realmName
        end
        local fullName = name.."-"..realm
        local guildIndex = self.rosterIndex[fullName]
        if guildIndex then
            local newValue = (self:GetCurrentDKP(fullName) or 0) + value
            self:SaveDKP(guildIndex, newValue, nil, reason)
        end
    end
    if reason then
        SendChatMessage(format("Raid received %d DKP for %s.", value, reason), "RAID")
    else
        SendChatMessage(format("Raid received %d DKP.", value), "RAID")
    end

end
function BohemkaDKP:SaveDKP(index, value, announceChannel, reason, isLocal)
    if not CanEditPublicNote() then
        return
    end

    local fullName = GetGuildRosterInfo(index)
    local prevValue = self.roster[fullName] or 0
    if value == nil then
        GuildRosterSetPublicNote(index, "")
        return
    end
    value = self:roundWhole(value, 1)
    local valueStr = string.format("%05d", value)
    GuildRosterSetPublicNote(index, valueStr)
    if announceChannel then
        local diff = value - prevValue
        local sign = ""
        if diff > 0 then
            sign = "+"
        end
        SendChatMessage(format("%s's DKP changed to %d (%s%d) for %s", strsplit("-", fullName), value, sign, diff, reason or "no reason"), announceChannel)
    end

    if not isLocal then
        self:ShareLog(GetServerTime(), fullName, prevValue, value, reason or "", self:GetPlayerName(true), 0)
    end
end
function BohemkaDKP:GetCurrentDKP(fullName)
    return self.roster[fullName or self:GetPlayerName(true)] or (self.rosterIndex[fullName] and BohemkaDKP:NoteDKPToNumber(select(7, GetGuildRosterInfo(self.rosterIndex[fullName]))) or nil)
end
function BohemkaDKP:NoteDKPToNumber(note)
    if note == nil then
        return
    end
    local value =  tonumber(note:match("0*(%d+)"))
    if note:sub(1, 1) == "-" then
        value = value * -1
    end
    return value
end
